﻿Imports Microsoft.VisualBasic
Imports System.Diagnostics

Namespace Log1

    Public Class Logger1
        Implements ILogger

        Public Sub Information(message As String) Implements ILogger.Information
            Debug.WriteLine(message)
            Trace.TraceInformation(message)
        End Sub

        Public Sub Information(fmt As String, ParamArray vars() As Object) Implements ILogger.Information
            Debug.WriteLine(fmt, vars)
            Trace.TraceInformation(fmt, vars)
        End Sub

        Public Sub Information(exception As Exception, fmt As String, ParamArray vars() As Object) Implements ILogger.Information
            Debug.WriteLine(FormatExceptionMessage(exception, fmt, vars))
            Trace.TraceInformation(FormatExceptionMessage(exception, fmt, vars))
        End Sub

        Public Sub Warning(message As String) Implements ILogger.Warning
            Debug.WriteLine(message)
            Trace.TraceWarning(message)
        End Sub

        Public Sub Warning(fmt As String, ParamArray vars() As Object) Implements ILogger.Warning
            Debug.WriteLine(fmt, vars)
            Trace.TraceWarning(fmt, vars)
        End Sub

        Public Sub Warning(exception As Exception, fmt As String, ParamArray vars() As Object) Implements ILogger.Warning
            Debug.WriteLine(FormatExceptionMessage(exception, fmt, vars))
            Trace.TraceWarning(FormatExceptionMessage(exception, fmt, vars))
        End Sub

        Public Sub [Error](message As String) Implements ILogger.Error
            Debug.WriteLine(message)
            Trace.TraceError(message)
        End Sub

        Public Sub [Error](fmt As String, ParamArray vars() As Object) Implements ILogger.Error
            Debug.WriteLine(fmt, vars)
            Trace.TraceError(fmt, vars)
        End Sub

        Public Sub [Error](exception As Exception, fmt As String, ParamArray vars() As Object) Implements ILogger.Error
            Debug.WriteLine(FormatExceptionMessage(exception, fmt, vars))
            Trace.TraceError(FormatExceptionMessage(exception, fmt, vars))
        End Sub

        Public Sub TraceApi(componentName As String, method As String, timespan As TimeSpan) Implements ILogger.TraceApi
            TraceApi(componentName, method, timespan, "")
        End Sub

        Public Sub TraceApi(componentName As String, method As String, timespan As TimeSpan, fmt As String, ParamArray vars() As Object) Implements ILogger.TraceApi
            TraceApi(componentName, method, timespan, String.Format(fmt, vars))
        End Sub

        Public Sub TraceApi(componentName As String, method As String, timespan As TimeSpan, properties As String) Implements ILogger.TraceApi
            Dim message As String = String.Concat("Component:", componentName, ";Method:", method, ";Timespan:", timespan.ToString(), ";Properties:", properties)
            Debug.WriteLine(message)
            Trace.TraceInformation(message)
        End Sub

        Private Shared Function FormatExceptionMessage(ByVal exception As Exception, ByVal fmt As String, ByVal vars As Object()) As String
            Dim sb = New StringBuilder()
            sb.Append(String.Format(fmt, vars))
            sb.Append(" Exception: ")
            sb.Append(exception.ToString())
            Return sb.ToString()
        End Function
    End Class
End Namespace